/**
 * vim: set ts=4 :
 * ======================================================
 * NephDSU
 * Written by Nephyrin@doublezen.net
 * -- is 99% composed of: --
 * Metamod:Source Stub Plugin
 * Written by AlliedModders LLC
 * ======================================================
 *
 * This software is provided 'as-is', without any express or implied warranty.
 * In no event will the authors be held liable for any damages arising from 
 * the use of this software.
 *
 * This plugin is public domain.
 *
 * Version: $Id$
 */

#include <stdio.h>
#include "NephDSU.h"

/** 
 * Something like this is needed to register cvars/CON_COMMANDs.
 */
class BaseAccessor : public IConCommandBaseAccessor
{
public:
	bool RegisterConCommandBase(ConCommandBase *pCommandBase)
	{
		/* Always call META_REGCVAR instead of going through the engine. */
		return META_REGCVAR(pCommandBase);
	}
} s_BaseAccessor;

/*class CUploadGameStats
{
public:
	virtual unsigned int UploadGameStats(char const *a, unsigned int b, unsigned int c, void const *d);
};*/

SH_DECL_MANUALHOOK4(UploadGameStats, 0, 0, 0, unsigned int, char const *, unsigned int , unsigned int , void const *)
SH_DECL_HOOK3_void(IServerGameDLL, ServerActivate, SH_NOATTRIB, 0, edict_t *, int, int);

NephDSU g_NephDSU;
IServerGameDLL *server = NULL;
void *gamestats = NULL;
ICvar *icvar = NULL;
static ConVar neph_nostats( "neph_nostats", "0", FCVAR_NONE,
	"Block stats reporting",
	true, 0.0f, true, 1.0f);

PLUGIN_EXPOSE(NephDSU, g_NephDSU);
bool NephDSU::Load(PluginId id, ISmmAPI *ismm, char *error, size_t maxlen, bool late)
{
	PLUGIN_SAVEVARS();
	//ServerUploadGameStats001
	/* Make sure we build on MM:S 1.4 */
	GET_V_IFACE_CURRENT(GetEngineFactory, icvar, ICvar, CVAR_INTERFACE_VERSION);
#if defined METAMOD_PLAPI_VERSION
	GET_V_IFACE_ANY(GetServerFactory, server, IServerGameDLL, INTERFACEVERSION_SERVERGAMEDLL);
	GET_V_IFACE_ANY(GetEngineFactory, gamestats, void *, "ServerUploadGameStats001");
#else
	GET_V_IFACE_ANY(serverFactory, server, IServerGameDLL, INTERFACEVERSION_SERVERGAMEDLL);
	GET_V_IFACE_ANY(engineFactory, gamestats, void *, "ServerUploadGameStats001");
#endif

	SH_ADD_HOOK_STATICFUNC(IServerGameDLL, ServerActivate, server, Hook_ServerActivate, true);
	SH_ADD_MANUALHOOK(UploadGameStats, gamestats, SH_MEMBER(&g_NephDSU, &NephDSU::Hook_UploadGameStats), false);
	
	#if SOURCE_ENGINE >= SE_ORANGEBOX
	g_pCVar = icvar;
	ConVar_Register(0, &s_BaseAccessor);
	#else
	ConCommandBaseMgr::OneTimeInit(&s_BaseAccessor);
	#endif
	
	return true;
}

bool NephDSU::Unload(char *error, size_t maxlen)
{
	SH_REMOVE_HOOK_STATICFUNC(IServerGameDLL, ServerActivate, server, Hook_ServerActivate, true);
	SH_REMOVE_MANUALHOOK(UploadGameStats, gamestats, SH_MEMBER(&g_NephDSU, &NephDSU::Hook_UploadGameStats), false);
	return true;
}

unsigned int NephDSU::Hook_UploadGameStats(char const *a, unsigned int b, unsigned int c, void const *d)
{
	if (neph_nostats.GetInt())
	{
		Msg("NephDSU: Stats upload *blocked*.\n");
		RETURN_META_VALUE(MRES_SUPERCEDE, 1);
	}
	else
	{
		Msg("NephDSU: Stats upload allowed.\n");
		RETURN_META_VALUE(MRES_IGNORED, 1);
	}
}

void Hook_ServerActivate(edict_t *pEdictList, int edictCount, int clientMax)
{
	//META_LOG(g_PLAPI, "ServerActivate() called: edictCount = %d, clientMax = %d", edictCount, clientMax);
}

void NephDSU::AllPluginsLoaded()
{
	/* This is where we'd do stuff that relies on the mod or other plugins 
	 * being initialized (for example, cvars added and events registered).
	 */
}

bool NephDSU::Pause(char *error, size_t maxlen)
{
	return true;
}

bool NephDSU::Unpause(char *error, size_t maxlen)
{
	return true;
}

const char *NephDSU::GetLicense()
{
	return "";
}

const char *NephDSU::GetVersion()
{
	return "1.1.0.0";
}

const char *NephDSU::GetDate()
{
	return __DATE__;
}

const char *NephDSU::GetLogTag()
{
	return "NephDSU";
}

const char *NephDSU::GetAuthor()
{
	return "Nephyrin@Doublezen.net";
}

const char *NephDSU::GetDescription()
{
	return "Adds neph_nostats to block stats uploading";
}

const char *NephDSU::GetName()
{
	return "NephDSU";
}

const char *NephDSU::GetURL()
{
	return "http://www.nephyrin.net/tools/NephDSU";
}
